<?php

namespace FM\Controller;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use FM\Service\ApontamentoService;
use FM\Traits\TResponse;

class ApontamentoController
{

    use TResponse;
    protected $ApontamentoService;

    public function __construct(ApontamentoService $ApontamentoService)
    {
        $this->ApontamentoService = $ApontamentoService;
    }

    public function setNewRegister(Request $request)
    {
        try {
            $data = $this->ApontamentoService->setNewRegister($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getUltimoRegistro()
    {
        try {
            $data = $this->ApontamentoService->getUltimoRegistro();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function optionLunch()
    {
        try {
            $data = $this->ApontamentoService->optionLunch();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getApontamentos()
    {
        try {
            $data = $this->ApontamentoService->getApontamentos();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function setAbsence(Request $request)
    {
        try {
            $data = $this->ApontamentoService->setAbsence($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function setLastAppointment(Request $request)
    {
        try {
            $data = $this->ApontamentoService->setLastAppointment($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
}
