<?php

namespace FM\Service;

use FM\Factory\QrCodeFactory;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;
use Doctrine\ORM\EntityManager;
use Endroid\QrCode\QrCode;

class QrCodeService
{

    protected $connection;
    protected $QrCodeFactory;
    protected $Environment;
    protected $newCode;

    public function __construct(EntityManager $entityManager, Environment $Environment, NewCode $newCode, QrCodeFactory $QrCodeFactory)
    {
        $this->connection               = $entityManager->getConnection();
        $this->Environment              = $Environment;
        $this->newCode                  = $newCode;
        $this->QrCodeFactory            = $QrCodeFactory;
    }

    public function buscaTarefasPorOperador($param)
    {
        $params = implode(',', $param);
        $resposta = $this->QrCodeFactory->buscaTarefasPorOperador($params);
        return $this->validaOperador($resposta, $param);
    }

    public function validaOperador($resposta, $param)
    {
        $cdoperadorPai = array_map(function ($user) {
            return $user['CDOPERADORPAI'];
        }, $resposta);

        $cdoperador = array_map(function ($user) {
            return $user['CDOPERADOR'];
        }, $resposta);
        
        $diaAtual = date('d/m/Y', strtotime("+1 days", strtotime(date('m/d/Y'))));
        $dataAtividadePendente = date('d/m/Y', strtotime("-365 days", strtotime(date('m/d/Y'))));
        $filtro = "";

        if (in_array($param["CDOPERADOR"], $cdoperadorPai)) {
            $filtro .= " AND VIST.DTHORAAGEND BETWEEN TO_DATE('$dataAtividadePendente' ,'DD/MM/YYYY') AND TO_DATE('$diaAtual' ,'DD/MM/YYYY')
            ORDER BY DTHORAAGEND DESC";
            $dados =  $this->QrCodeFactory->findVistoria($param, $filtro);
            array_push($dados, 'PAI');
            return $dados;
        } elseif (in_array($param["CDOPERADOR"], $cdoperador)) {
            $filtro .= " AND TAREF.DTHORAAGEND BETWEEN TO_DATE('$dataAtividadePendente' ,'DD/MM/YYYY') AND TO_DATE('$diaAtual' ,'DD/MM/YYYY')
            ORDER BY TAREF.DTHORAAGEND DESC";
            $dados = $this->QrCodeFactory->findTarefa($param, $filtro);
            array_push($dados, 'FILHO');
            return $dados;
        } else {
            echo "NL";
            return;
        }
    }
}
